#pragma once

#include "types.h"

#define CHACHA20_KEY_LEN   32
#define CHACHA20_NONCE_LEN 12
#define CHACHA20_STATE_LEN 16

typedef struct chacha20_ctx_s {
  
  u64 counter;
  u64 position;
  
  u8 key[CHACHA20_KEY_LEN];
  u8 nonce[CHACHA20_NONCE_LEN];
  
  u32 state[CHACHA20_STATE_LEN];
  u32 keystream32[CHACHA20_STATE_LEN];
  
} chacha20_ctx_t;

void passman_chacha20(u8 *msg, u64 len, u8 *key, u8 *nonce, u8 *out);
