#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "types.h"

void passman_error(const ascii *module, u8 exit_status, const ascii *format, ...)
{
  if (module)
    fprintf(stderr, "# ERROR (%s): ", module);
  else
    fprintf(stderr, "# ERROR: ");
  
  va_list args;

  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);
  
  exit(exit_status);
}

void passman_warning(const ascii *module, const ascii *format, ...)
{
  if (module)
    fprintf(stderr, "# WARNING (%s): ", module);
  else
    fprintf(stderr, "# WARNING: ");
  
  va_list args;

  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);
}

