#include "types.h"

void passman_memset(u8 *mem, const u8 c, const u64 len)
{
  u64 l = len;
  u8 *p = mem;

  while (l-- > 0)
    *p++ = c;
}

void passman_memzero(u8 *mem, const u64 len)
{
  u64 l = len;
  u8 *p = mem;

  while (l-- > 0)
    *p++ = 0;
}

void passman_memcpy(u8 *dst, u8 *src, const u64 len)
{
  u64 l = len;
  u8 *d = dst;
  u8 *s = src;

  while (l-- > 0)
    {
      *d = *s;
      d++;
      s++;
    }
}

u8 passman_memcmp(u8 *mem1, u8 *mem2, const u64 len)
{
  u8 r = 0;
  u64 l = len;
  u8 *p1 = mem1;
  u8 *p2 = mem2;
  
  while (l-- > 0)
    {
      r |= *p1 ^ *p2;
      
      p1++;
      p2++;
    }
  
  r |= r >> 4;
  r |= r >> 2;
  r |= r >> 1;
  r &= 1;
  
  return r;
}
