#pragma once

#include "types.h"
#include "const.h"
#include "sha3.h"
#include "chacha20.h"

typedef struct passman_db_entry_s {
  
  u8 is_used;
  
  u32 id;
  
  ascii description[PASSMAN_MAX_STR];  
  ascii login[PASSMAN_MAX_STR];
  ascii password[PASSMAN_MAX_STR];
  
  u64 iter;
  u8 salt[PASSMAN_SALT_LEN];
  u8 nonce[CHACHA20_NONCE_LEN]; 
  u8 hmac[SHA3_256_HASH_LEN];
  
} __attribute__((packed)) passman_db_entry_t;

typedef struct passman_db_s {
  
  passman_db_entry_t entries[PASSMAN_MAX_ENTRIES];
  
  u64 iter;
  u8 salt[PASSMAN_SALT_LEN];
  u8 nonce[CHACHA20_NONCE_LEN]; 
  u8 entries_hmac[SHA3_256_HASH_LEN];
  u8 hmac[SHA3_256_HASH_LEN];
  
} __attribute__((packed)) passman_db_t;
