#pragma once

#include "types.h"

#define SHA3_256_HASH_LEN       32
#define SHA3_512_HASH_LEN       64
#define SHA3_256_HMAC_BLOCK_LEN 136
#define SHA3_512_HMAC_BLOCK_LEN 72

#define lrot64(v, s) (((v) << (s)) | ((v) >> ((sizeof(u64) * 8) - (s))))

typedef struct {
  
  union {             
    u8 b[200];   
    u64 q[25];   
  } st;
  
  u64 pt, rsiz, mdlen;
  
} sha3_context_t;

void passman_sha3_256(u8 *in, u64 len, u8 *hash);
void passman_sha3_512(u8 *in, u64 len, u8 *hash);
void passman_sha3_256_hmac(u8* in, u64 in_len, u8* key, u64 key_len, u8* hash);
void passman_sha3_512_hmac(u8* in, u64 in_len, u8* key, u64 key_len, u8* hash);
